//+------------------------------------------------------------------+
//|Stochastic_MA.mq4.mq4
//| leonid553 
//| http://www.tradersforum.net.ru/
//+------------------------------------------------------------------+
#property copyright "leonid553 & co"
#property link      "http://www.tradersforum.net.ru/"

//---- input parameters---------
extern bool   Long =true;
extern bool   Short =true;
extern string   _____= "  "; 
extern int     Stochastic_period  =24;
extern int     MA_period          =11;
extern double  Deviation_         =7;
extern int     lMinProfit         = 53;
extern int     lTrailingStop      = 63;
extern int     lTrailingStep      = 5;
extern string   ____= "  ";
extern int     Stochastic_period_SELL  =25;          
extern int     MA_period_SELL          =7;
extern double  Deviation_SELL          =22;
extern int     sMinProfit              = 53;
extern int     sTrailingStop           = 53;
extern int     sTrailingStep           = 5;
//------------------------------
extern string   _= "   ";
extern int     TP=200;
extern int     SL=61;
extern double  Lot=0.1;
extern int     Slippage=3;
extern bool    UseTrailing = true;
extern int     MagicLong=5675; 
extern int     MagicShort=8976; 
//-------------------
int ExpertBars;
int ticket;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {ExpertBars = Bars;
   return(0);  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {  return(0);  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
bool isNewBar=false;
if (ExpertBars !=Bars) {ExpertBars=Bars; isNewBar=true; }
if (isNewBar) {  
//=====      =========================================
//--------------- ------------------------------------------
if (Long)                   {     // "" 
if (!ExpertOrder( MagicLong ))  {//      

double Stochastic_array_buy[30];int j=0; while (j<31) {
Stochastic_array_buy[j]= iStochastic(NULL, 0, Stochastic_period, 3,3,
                                               MODE_SMA,0,MODE_MAIN, j); j++; }
ArraySetAsSeries(Stochastic_array_buy,true);
double MA_low =iMAOnArray(Stochastic_array_buy,0,MA_period,1,MODE_SMA,0)-Deviation_;
double Stochastic_0=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 0);
double Stochastic_1=iStochastic(NULL, 0, Stochastic_period, 3,3,MODE_SMA,0,MODE_MAIN, 1);   
//---------   ----------------------------
  if   (           (Stochastic_1<MA_low)  &&  (Stochastic_0>MA_low)  )   {
  ticket=OrderSend(Symbol(),0,Lot,Ask,Slippage,Bid-SL*Point,Ask+TP*Point,NULL,
                                                                 MagicLong,0,CLR_NONE);
  if (ticket<0) { Print("   BUY #", GetLastError()); return (0);   }          
   }}} // "" 
   
//---------- ----- ----------------------------------------------- 
if (Short)                   {     // ""  
if (!ExpertOrder( MagicShort )) {  //      
double Stochastic_array_sell[30]; int k=0; while (k<31) {
Stochastic_array_sell[k]= iStochastic(NULL, 0,Stochastic_period_SELL, 3,3,
                                              MODE_SMA,0,MODE_MAIN, k);  k++; }
ArraySetAsSeries(Stochastic_array_sell,true);
double MA_up =iMAOnArray(Stochastic_array_sell,0, MA_period_SELL ,1,MODE_SMA,0)
                                                                + Deviation_SELL;
double Stochastic_0s=iStochastic(NULL, 0, Stochastic_period_SELL, 3,3,MODE_SMA,
                                                                 0,MODE_MAIN, 0);
double Stochastic_1s=iStochastic(NULL, 0, Stochastic_period_SELL, 3,3,MODE_SMA,
                                                                   0,MODE_MAIN, 1);    
//--------   ------------------------------
  if  (           (Stochastic_1s > MA_up )  &&  (Stochastic_0s < MA_up ))  {       
  ticket=OrderSend(Symbol(),1,Lot,Bid,Slippage,Bid+SL*Point,Bid-TP*Point,NULL,
                                                               MagicShort,0,CLR_NONE);
  if (ticket<0) {Print("   SELL #",GetLastError()); return (0); }     
   }}}  // "" 
//===================================================================================
if (UseTrailing) TrailPositions(); 
   } //isNewBar 
   return(0);
  }
//+------------------------------------------------------------------+
void TrailPositions() // 
{
 int Orders = OrdersTotal();
  for (int i=0; i<Orders; i++) {
    if (!(OrderSelect(i, SELECT_BY_POS, MODE_TRADES))) continue;
    if (OrderSymbol() != Symbol()) continue;  
    if (OrderType() == OP_BUY) {
      if (Bid-OrderOpenPrice() > lMinProfit*Point) {
        if (OrderStopLoss() < Bid-(lTrailingStop+lTrailingStep-1)*Point) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Bid-lTrailingStop*Point,
                                                   OrderTakeProfit(), 0, Blue);
        }} }
    if (OrderType() == OP_SELL) {
      if (OrderOpenPrice()-Ask > sMinProfit*Point) {
        if (OrderStopLoss() > Ask+(sTrailingStop+sTrailingStep-1)*Point ||
                                                     OrderStopLoss() == 0) {
          OrderModify(OrderTicket(), OrderOpenPrice(), Ask+sTrailingStop*Point,
                                                   OrderTakeProfit(), 0, Blue);
        }}}}}
  //********************************************
//---------------------------------------------------------------------------------+
//----      ----------------------------------+
bool ExpertOrder (int VersionID){
bool result=false;
int  _OrdersTotal=OrdersTotal();
if (_OrdersTotal>0) {
    for (int v=0; v<_OrdersTotal; v++) {    
      if (OrderSelect(v, SELECT_BY_POS, MODE_TRADES)) {
        if (OrderMagicNumber()==VersionID) 
           { result=true;  break; }
        else   { result=false; } 
       } } }
else { result=false; }  
return(result);
}